
/* image access from C -- lars appel 11.feb.02 */

#pragma list off
#include <stdio.h>
#include <string.h>
/*
 include <stdlib.h>
*/
#pragma list on

#pragma intrinsic DBOPEN
#pragma intrinsic DBCLOSE
#pragma intrinsic DBFIND
#pragma intrinsic DBGET
#pragma intrinsic DBPUT
#pragma intrinsic DBUPDATE
#pragma intrinsic DBDELETE
#pragma intrinsic DBINFO
#pragma intrinsic DBEXPLAIN
#pragma intrinsic DBERROR
#pragma intrinsic DBLOCK
#pragma intrinsic DBUNLOCK
#pragma intrinsic DBBEGIN
#pragma intrinsic DBEND

#define End_Of_Chain 15       /* For DBGET Mode 5 */
#define End_Of_Data_Set 11    /* For DBGET Mode 2 */
#define No_Chain_Head 17      /* For DBFIND */
#define No_Such_Entry 17      /* For DBGET Mode 7 */
#define Entry_Has_No_Data 17  /* For DBGET Mode 4 */

struct Database_Status_Type
{
    short Condition;
    short Length;
    int   Record_Number;
    int   Chain_Count;
    int   Back_Pointer;
    int   Forward_Pointer;
}
Status;

struct Products_Entry_Type
{
  char  product_no[6];
  char  product_name[16];
  char  price[4]; /* packed decimal */
  char  product_line[2];
  short quantity;
}
Products_buf;

char oops[1024];

short   DBname[6],
        Password[4],
        Products_set[8],
        List[40],
        Dummy,
        Mode;

main()
{
  printf("opening db...\n");

  strcpy( (char *)DBname, "  TOYDB;" );
  strcpy( (char *)Password, "reading;" );

  Mode = 1;

  DBOPEN(DBname, Password, &Mode, &Status);

  if (Status.Condition != 0) {
    DBEXPLAIN(&Status);
    exit(1);
  }

  printf("listing products...\n");

  strcpy( (char *)Products_set, "PRODUCTS;" );
  strcpy( (char *)List, "@;");

  Mode = 2;

  do {
    DBGET(
      DBname, Products_set, &Mode, &Status, List, &Products_buf, &Dummy
    );

    if (Status.Condition == 0) {
      printf(
       "%9.6s %19.16s %6d\n",
       Products_buf.product_no,
       Products_buf.product_name,
       Products_buf.quantity
      );
    }
  }
  while (Status.Condition == 0);

  if (Status.Condition != End_Of_Data_Set) {
    DBEXPLAIN(&Status);
    exit(3);
  }

  printf("closing db...\n");

  Mode = 1;

  DBCLOSE(DBname, Password, &Mode, &Status);

  if (Status.Condition != 0) {
    DBEXPLAIN(&Status);
    exit(2);
  }
}

